package asynchqueuereceiver;
import javax.jms.*;

/**
 * Der Text Listener implementiert das MessageListener Interface
 * mittels einer onMessage Methode, die den Inhalt einer Text Message anzeigt
 * <p>
 * Die Klasse dient der Klasse AsynchQueueReceiver als Listener
 */
public class TextListener implements MessageListener {
    final Hilfsklassen.DoneLatch  monitor =
        new Hilfsklassen.DoneLatch();

    /**
     * Casten der Message in eine TextMessage und Anzeige des Textes
     * Nicht-Text Messages werden als Ende des Messagestromes interpretiert.
     *
     * @param message	die eintreffende Message
     */
    public void onMessage(Message message) {
        if (message instanceof TextMessage) {
            TextMessage  msg = (TextMessage) message;

            try {
                System.out.println("Messages werden gelesen: " + msg.getText());
            } catch (JMSException e) {
                System.out.println("Exception in onMessage(): " + e.toString());
            }
        } else {
            monitor.allDone();
        }
    }
}
