package einfachertopicsubscriber;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

 /**
 * TextListener implementiert das MessageListener
 * Interface mittels einer onMessage Methode
 * Diese zeigt den Inhalt einer Text Meldung an
 *
 * Diese Klasse ist fr die Anwendung EinfacherTopicSubscriber
 * bestimmt.
 */
import javax.jms.*;

public class TextListener implements MessageListener {

    /**
     * Casten der Message in eine Text Message und Ausgabe des Textes
     *
     * @param message     eintreffende Message
     */
    public void onMessage(Message message) {
        TextMessage msg = null;

        try {
            if (message instanceof TextMessage) {
                msg = (TextMessage) message;
                System.out.println("Message wird gelesen: " +
                    msg.getText());
            } else {
                System.out.println("Keine Text Message: "
                    + message.getClass().getName());
            }
        } catch (JMSException e) {
            System.out.println("JMSException in onMessage(): " +
                e.toString());
        } catch (Throwable te) {
            System.out.println("Exception in onMessage():"
                + te.getMessage());
        }
    }
}
