package objektmessages;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

 import javax.jms.*;

/**
 * ObjectMessages
 * kopieren von Objekten und kreieren einer ObjektMessage
 * <p>
 * ObjectMessage und BytesMessage werden benutzt
 *
 */
public class ObjectMessages {

    /**
     * Main method.  Kein Argument.
     */
    public static void main(String[] args) {
        QueueConnectionFactory  queueConnectionFactory = null;
        QueueConnection         queueConnection = null;
        QueueSession            queueSession = null;
        ObjectMessage           objectMessage = null;
        String                  object = "Ein String ist ein Objekt.";
        BytesMessage            bytesMessage = null;
        byte[]                  byteArray = {3, 5, 7, 9, 11};
        final int               ARRLEN = 5;
        int                     length = 0;
        byte[]                  inByteData = new byte[ARRLEN];
        int                     exitResult = 0;

    	try {
            queueConnectionFactory =
                Hilfsklassen.getQueueConnectionFactory();
    	    queueConnection =
    	        queueConnectionFactory.createQueueConnection();
    	    queueSession = queueConnection.createQueueSession(false,
    	        Session.AUTO_ACKNOWLEDGE);
    	} catch (Exception e) {
            System.out.println("Connection Problem: " + e.toString());
            if (queueConnection != null) {
                try {
                    queueConnection.close();
                } catch (JMSException ee) {}
            }
    	    System.exit(1);
    	}

        try {
    	    /*
    	     * ObjectMessage aus String.
    	     * Modifikation des Strings.
    	     * Lesen der Message : das Objekt ist das alte
             */
    	    objectMessage = queueSession.createObjectMessage();
    	    System.out.println("[ObjectMessage]Schreiben des Strings in die Message:  " + object);
    	    objectMessage.setObject(object);
    	    object = "Ich bin der modifizierte String.";
    	    System.out.println("\t\tModifiziertes Objekt:  " + object);
            System.out.println("[ObjectMessage]alter String aus der ObjectMessage:  " +
                (String) objectMessage.getObject());

    	    /*
    	     * BytesMessage aus Byte Array
    	     * Modifikation des Arrays
    	     * Reset und read der Message
             * Das alte Objekt steht drin
    	     */
    	    bytesMessage = queueSession.createBytesMessage();
    	    System.out.print("[BytesMessage]Schreiben des Arrays in die Message: ");
            for (int i = 0; i < ARRLEN; i++) {
                System.out.print(" " + byteArray[i]);
    	    }
    	    System.out.println();
    	    bytesMessage.writeBytes(byteArray);
    	    byteArray[1] = 13;
    	    System.out.print("\t\tveraendern des Arrays; \n\t\tDas Array ist nun: ");
            for (int i = 0; i < ARRLEN; i++) {
                System.out.print(" " + byteArray[i]);
    	    }
    	    System.out.println();
    	    bytesMessage.reset();
            length = bytesMessage.readBytes(inByteData);
            System.out.print("[BytesMessage]Die BytesMessage enthlt: ");
            for (int i = 0; i < length; i++) {
                System.out.print(" " + inByteData[i]);
            }
    	    System.out.println();
    	} catch (JMSException e) {
    	    System.out.println("Eine Exception trat auf: " + e.toString());
    	    exitResult = 1;
    	} finally {
            if (queueConnection != null) {
                try {
                    queueConnection.close();
                } catch (JMSException e) {
    	            exitResult = 1;
                }
    	    }
    	}
    	Hilfsklassen.exit(exitResult);
    }
}
